// igChartLegend extension
/*global WinJS, $*/
(function () {
    WinJS.Namespace.define('Infragistics.UI', {
        ChartLegend: WinJS.Class.define(function (element, options) {
			// This needs to be defined for all widgets
            if (!element) {
                throw new Error("The Infragistics control requires a DOM element to be instantiated on.");
            }
			this._element = element;
			// Initializes the control
			$(element).igChartLegend(options);
			this.element.winControl = this;
        }, {
			// Private properties
			_element: null,
            // Public options
			// The element option is generic for all widget and is only a getter
			element: {
                get: function () {
                    return this._element;
                }
            },
						/// <field type="Enumeration">
			///  Type of the legend.
			/// </field>
			type: {
				get: function () {
					return $(this._element).igChartLegend('option', 'type');
				},
				set: function (value) {
					$(this._element).igChartLegend('option', 'type', value);
				}
			},
			/// <field type="Enumeration">
			///  The width of the legend.
			/// </field>
			width: {
				get: function () {
					return $(this._element).igChartLegend('option', 'width');
				},
				set: function (value) {
					$(this._element).igChartLegend('option', 'width', value);
				}
			},
			/// <field type="Enumeration">
			///  The height of the legend.
			/// </field>
			height: {
				get: function () {
					return $(this._element).igChartLegend('option', 'height');
				},
				set: function (value) {
					$(this._element).igChartLegend('option', 'height', value);
				}
			},
			/// <field type="String">
			/// The swatch used to style this widget
			/// </field>
			theme: {
				get: function () {
					return $(this._element).igChartLegend('option', 'theme');
				},
				set: function (value) {
					$(this._element).igChartLegend('option', 'theme', value);
				}
			},

			// Public methods
			/*
			destroy: function igChartLegend_destroy() {
				$(this._element).igChartLegend('destroy');
			}
			*/
						/* 
			*/
            destroy: function ChartLegend_destroy () {
                $(this._element).igChartLegend('destroy');
            },
			/* Returns the element holding the legend.
			*/
            widget: function ChartLegend_widget () {
                $(this._element).igChartLegend('widget');
            },
			/* returns the ID of the DOM element holding the legend.
			*/
            id: function ChartLegend_id () {
                $(this._element).igChartLegend('id');
            }

        }, {
			// Static members
		})
    });
}());