// igCurrencyEditor extension
/*global WinJS, $*/
(function () {
    WinJS.Namespace.define('Infragistics.UI', {
        CurrencyEditor: WinJS.Class.define(function (element, options) {
			// This needs to be defined for all widgets
            if (!element) {
                throw new Error("The Infragistics control requires a DOM element to be instantiated on.");
            }
			this._element = element;
			// Initializes the control
			MSApp.execUnsafeLocalFunction(function () {
				$(element).igCurrencyEditor(options);
			});
			this.element.winControl = this;
        }, {
			// Private properties
			_element: null,
            // Public options
			// The element option is generic for all widget and is only a getter
			element: {
                get: function () {
                    return this._element;
                }
            },
						/// <field type="String">
			/// Sets gets the pattern for positive numeric values, which is used in display (no focus) state.
///				The "$" flag represents "numericSymbol" and the "n" flag represents the value of number.
///				Note: this option has priority over possible regional settings.
			/// </field>
			positivePattern: {
				get: function () {
					return $(this._element).igCurrencyEditor('option', 'positivePattern');
				},
				set: function (value) {
					$(this._element).igCurrencyEditor('option', 'positivePattern', value);
				}
			},
			/// <field type="String">
			/// Sets gets the pattern for negative numeric values, which is used in display (no focus) state.
///				The "$" flag represents "numericSymbol".
///				The "n" flag represents the value of number.
///				The "-" and "()" flags are static part of pattern.
///				Note: this option has priority over possible regional settings.
			/// </field>
			negativePattern: {
				get: function () {
					return $(this._element).igCurrencyEditor('option', 'negativePattern');
				},
				set: function (value) {
					$(this._element).igCurrencyEditor('option', 'negativePattern', value);
				}
			},
			/// <field type="String">
			/// Sets gets symbol, which is used in display (no focus) state.
///				Note: this option has priority over possible regional settings.
			/// </field>
			symbol: {
				get: function () {
					return $(this._element).igCurrencyEditor('option', 'symbol');
				},
				set: function (value) {
					$(this._element).igCurrencyEditor('option', 'symbol', value);
				}
			},

			// Public methods
			/*
			destroy: function igCurrencyEditor_destroy() {
				$(this._element).igCurrencyEditor('destroy');
			}
			*/
			
        }, {
			// Static members
		})
    });
}());