// igDataChart extension
/*global WinJS, $*/
(function () {
    WinJS.Namespace.define('Infragistics.UI', {
        DataChart: WinJS.Class.define(function (element, options) {
			// This needs to be defined for all widgets
            if (!element) {
                throw new Error("The Infragistics control requires a DOM element to be instantiated on.");
            }
			this._element = element;
            // Initializes the control
			MSApp.execUnsafeLocalFunction(function () {
			    $(element).igDataChart(options);
			});
			this.element.winControl = this;
        }, {
			// Private properties
			_element: null,
            // Public options
			// The element option is generic for all widget and is only a getter
			element: {
                get: function () {
                    return this._element;
                }
            },
						/// <field type="String">
			/// The channel name to use to sync this chart with other charts.
			/// </field>
			syncChannel: {
				get: function () {
					return $(this._element).igDataChart('option', 'syncChannel');
				},
				set: function (value) {
					$(this._element).igDataChart('option', 'syncChannel', value);
				}
			},
			/// <field type="Bool">
			/// Whether the chart should be synchronized vertically
			/// </field>
			synchronizeVertically: {
				get: function () {
					return $(this._element).igDataChart('option', 'synchronizeVertically');
				},
				set: function (value) {
					$(this._element).igDataChart('option', 'synchronizeVertically', value);
				}
			},
			/// <field type="Bool">
			/// Whether the chart should be synchronized horizontally
			/// </field>
			syncrhonizeHorizontally: {
				get: function () {
					return $(this._element).igDataChart('option', 'syncrhonizeHorizontally');
				},
				set: function (value) {
					$(this._element).igDataChart('option', 'syncrhonizeHorizontally', value);
				}
			},
			/// <field type="Object">
			/// Gets or sets the cross hair point (in world coordinates)
			/// Either or both of the crosshair point's X and Y may be set to double.NaN, in which
			/// case the relevant crosshair line is hidden.
			/// </field>
			crosshairPoint: {
				get: function () {
					return $(this._element).igDataChart('option', 'crosshairPoint');
				},
				set: function (value) {
					$(this._element).igDataChart('option', 'crosshairPoint', value);
				}
			},
			/// <field type="Object">
			/// A rectangle representing the portion of the chart currently in view.
			/// A rectangle at X=0, Y=0 with a Height and Width of 1 implies the entire plotting area is in view.  A Height and Width of .5 would imply that the view is halfway zoomed in.
			/// The provided object should have numeric properties called left, top, width and height.
			/// </field>
			windowRect: {
				get: function () {
					return $(this._element).igDataChart('option', 'windowRect');
				},
				set: function (value) {
					$(this._element).igDataChart('option', 'windowRect', value);
				}
			},
			/// <field type="Bool">
			/// Gets or sets the current Chart's horizontal zoomability.
			/// </field>
			horizontalZoomable: {
				get: function () {
					return $(this._element).igDataChart('option', 'horizontalZoomable');
				},
				set: function (value) {
					$(this._element).igDataChart('option', 'horizontalZoomable', value);
				}
			},
			/// <field type="Bool">
			/// Gets or sets the current Chart's vertical zoomability.
			/// </field>
			verticalZoomable: {
				get: function () {
					return $(this._element).igDataChart('option', 'verticalZoomable');
				},
				set: function (value) {
					$(this._element).igDataChart('option', 'verticalZoomable', value);
				}
			},
			/// <field type="Enumeration">
			/// 
			/// </field>
			windowResponse: {
				get: function () {
					return $(this._element).igDataChart('option', 'windowResponse');
				},
				set: function (value) {
					$(this._element).igDataChart('option', 'windowResponse', value);
				}
			},
			/// <field type="Number">
			/// Sets or gets the minimum width that the window rect is allowed to reach before being clamped.
			/// Decrease this value if you want to allow for further zooming into the viewer.
			/// If this value is lowered too much it can cause graphical corruption due to floating point arithmetic inaccuracy.
			/// </field>
			windowRectMinWidth: {
				get: function () {
					return $(this._element).igDataChart('option', 'windowRectMinWidth');
				},
				set: function (value) {
					$(this._element).igDataChart('option', 'windowRectMinWidth', value);
				}
			},
			/// <field type="Enumeration">
			///  The visibility of the OverviewPlusDetailPane.
			/// </field>
			overviewPlusDetailPaneVisibility: {
				get: function () {
					return $(this._element).igDataChart('option', 'overviewPlusDetailPaneVisibility');
				},
				set: function (value) {
					$(this._element).igDataChart('option', 'overviewPlusDetailPaneVisibility', value);
				}
			},
			/// <field type="Enumeration">
			///  Gets or sets the current Chart's crosshair visibility override.
			/// </field>
			crosshairVisibility: {
				get: function () {
					return $(this._element).igDataChart('option', 'crosshairVisibility');
				},
				set: function (value) {
					$(this._element).igDataChart('option', 'crosshairVisibility', value);
				}
			},
			/// <field type="String">
			/// Gets or sets the brush used as the background for the current Chart object's plot area.
			/// </field>
			plotAreaBackground: {
				get: function () {
					return $(this._element).igDataChart('option', 'plotAreaBackground');
				},
				set: function (value) {
					$(this._element).igDataChart('option', 'plotAreaBackground', value);
				}
			},
			/// <field type="Enumeration">
			///  Gets or sets the DefaultInteraction property. The default interaction state defines the chart's response to mouse events.
			/// </field>
			defaultInteraction: {
				get: function () {
					return $(this._element).igDataChart('option', 'defaultInteraction');
				},
				set: function (value) {
					$(this._element).igDataChart('option', 'defaultInteraction', value);
				}
			},
			/// <field type="Enumeration">
			///  Gets or sets the current Chart's DragModifier property.
			/// </field>
			dragModifier: {
				get: function () {
					return $(this._element).igDataChart('option', 'dragModifier');
				},
				set: function (value) {
					$(this._element).igDataChart('option', 'dragModifier', value);
				}
			},
			/// <field type="Enumeration">
			///  Gets or sets the current Chart's PanModifier property.
			/// </field>
			panModifier: {
				get: function () {
					return $(this._element).igDataChart('option', 'panModifier');
				},
				set: function (value) {
					$(this._element).igDataChart('option', 'panModifier', value);
				}
			},
			/// <field type="Object">
			/// Gets or sets the preview rectangle.
			/// The preview rectangle may be set to Rect.Empty, in which case the visible preview
			/// strokePath is hidden.
			/// The provided object should have numeric properties called left, top, width and height.
			/// </field>
			previewRect: {
				get: function () {
					return $(this._element).igDataChart('option', 'previewRect');
				},
				set: function (value) {
					$(this._element).igDataChart('option', 'previewRect', value);
				}
			},
			/// <field type="Number">
			/// A number between 0 and 1 determining the position of the horizontal scroll.
			/// This property is effectively a shortcut to the X position of the WindowRect property.
			/// </field>
			windowPositionHorizontal: {
				get: function () {
					return $(this._element).igDataChart('option', 'windowPositionHorizontal');
				},
				set: function (value) {
					$(this._element).igDataChart('option', 'windowPositionHorizontal', value);
				}
			},
			/// <field type="Number">
			/// A number between 0 and 1 determining the position of the vertical scroll.
			/// This property is effectively a shortcut to the Y position of the WindowRect property.
			/// </field>
			windowPositionVertical: {
				get: function () {
					return $(this._element).igDataChart('option', 'windowPositionVertical');
				},
				set: function (value) {
					$(this._element).igDataChart('option', 'windowPositionVertical', value);
				}
			},
			/// <field type="Number">
			/// A number between 0 and 1 determining the scale of the horizontal zoom.
			/// This property is effectively a shortcut to the Width of the WindowRect property.
			/// </field>
			windowScaleHorizontal: {
				get: function () {
					return $(this._element).igDataChart('option', 'windowScaleHorizontal');
				},
				set: function (value) {
					$(this._element).igDataChart('option', 'windowScaleHorizontal', value);
				}
			},
			/// <field type="Number">
			/// A number between 0 and 1 determining the scale of the vertical zoom.
			/// This property is effectively a shortcut to the Height of the WindowRect property.
			/// </field>
			windowScaleVertical: {
				get: function () {
					return $(this._element).igDataChart('option', 'windowScaleVertical');
				},
				set: function (value) {
					$(this._element).igDataChart('option', 'windowScaleVertical', value);
				}
			},
			/// <field type="Object">
			/// Gets or sets the template to use for circle markers on the chart.
			/// Defines the marker template used for
			/// series with a marker type of circle.
			/// The provided object should have properties called render and optionally measure. See definition for option: legendItemBadgeTemplate
			/// </field>
			circleMarkerTemplate: {
				get: function () {
					return $(this._element).igDataChart('option', 'circleMarkerTemplate');
				},
				set: function (value) {
					$(this._element).igDataChart('option', 'circleMarkerTemplate', value);
				}
			},
			/// <field type="Object">
			/// Gets or sets the template to use for triangle markers on the chart.
			/// Defines the marker template used for
			/// series with a marker type of triangle.
			/// The provided object should have properties called render and optionally measure. See definition for option: legendItemBadgeTemplate
			/// </field>
			triangleMarkerTemplate: {
				get: function () {
					return $(this._element).igDataChart('option', 'triangleMarkerTemplate');
				},
				set: function (value) {
					$(this._element).igDataChart('option', 'triangleMarkerTemplate', value);
				}
			},
			/// <field type="Object">
			/// Gets or sets the template to use for pyramid markers on the chart.
			/// Defines the marker template used for
			/// series with a marker type of pyramid.
			/// The provided object should have properties called render and optionally measure. See definition for option: legendItemBadgeTemplate
			/// </field>
			pyramidMarkerTemplate: {
				get: function () {
					return $(this._element).igDataChart('option', 'pyramidMarkerTemplate');
				},
				set: function (value) {
					$(this._element).igDataChart('option', 'pyramidMarkerTemplate', value);
				}
			},
			/// <field type="Object">
			/// Gets or sets the template to use for square markers on the chart.
			/// Defines the marker template used for
			/// series with a marker type of square.
			/// The provided object should have properties called render and optionally measure. See definition for option: legendItemBadgeTemplate
			/// </field>
			squareMarkerTemplate: {
				get: function () {
					return $(this._element).igDataChart('option', 'squareMarkerTemplate');
				},
				set: function (value) {
					$(this._element).igDataChart('option', 'squareMarkerTemplate', value);
				}
			},
			/// <field type="Object">
			/// Gets or sets the template to use for diamond markers on the chart.
			/// Defines the marker template used for
			/// series with a marker type of diamond.
			/// The provided object should have properties called render and optionally measure. See definition for option: legendItemBadgeTemplate
			/// </field>
			diamondMarkerTemplate: {
				get: function () {
					return $(this._element).igDataChart('option', 'diamondMarkerTemplate');
				},
				set: function (value) {
					$(this._element).igDataChart('option', 'diamondMarkerTemplate', value);
				}
			},
			/// <field type="Object">
			/// Gets or sets the template to use for pentagon markers on the chart.
			/// Defines the marker template used for
			/// series with a marker type of pentagon.
			/// The provided object should have properties called render and optionally measure. See definition for option: legendItemBadgeTemplate
			/// </field>
			pentagonMarkerTemplate: {
				get: function () {
					return $(this._element).igDataChart('option', 'pentagonMarkerTemplate');
				},
				set: function (value) {
					$(this._element).igDataChart('option', 'pentagonMarkerTemplate', value);
				}
			},
			/// <field type="Object">
			/// Gets or sets the template to use for hexagon markers on the chart.
			/// Defines the marker template used for
			/// series with a marker type of hexagon.
			/// The provided object should have properties called render and optionally measure. See definition for option: legendItemBadgeTemplate
			/// </field>
			hexagonMarkerTemplate: {
				get: function () {
					return $(this._element).igDataChart('option', 'hexagonMarkerTemplate');
				},
				set: function (value) {
					$(this._element).igDataChart('option', 'hexagonMarkerTemplate', value);
				}
			},
			/// <field type="Object">
			/// Gets or sets the template to use for tetragram markers on the chart.
			/// Defines the marker template used for
			/// series with a marker type of tetragram.
			/// The provided object should have properties called render and optionally measure. See definition for option: legendItemBadgeTemplate
			/// </field>
			tetragramMarkerTemplate: {
				get: function () {
					return $(this._element).igDataChart('option', 'tetragramMarkerTemplate');
				},
				set: function (value) {
					$(this._element).igDataChart('option', 'tetragramMarkerTemplate', value);
				}
			},
			/// <field type="Object">
			/// Gets or sets the template to use for pentragram markers on the chart.
			/// Defines the marker template used for
			/// series with a marker type of pentagram.
			/// The provided object should have properties called render and optionally measure. See definition for option: legendItemBadgeTemplate
			/// </field>
			pentagramMarkerTemplate: {
				get: function () {
					return $(this._element).igDataChart('option', 'pentagramMarkerTemplate');
				},
				set: function (value) {
					$(this._element).igDataChart('option', 'pentagramMarkerTemplate', value);
				}
			},
			/// <field type="Object">
			/// Gets or sets the template to use for hexagram markers on the chart.
			/// Defines the marker template used for
			/// series with a marker type of hexagram.
			/// The provided object should have properties called render and optionally measure. See definition for option: legendItemBadgeTemplate
			/// </field>
			hexagramMarkerTemplate: {
				get: function () {
					return $(this._element).igDataChart('option', 'hexagramMarkerTemplate');
				},
				set: function (value) {
					$(this._element).igDataChart('option', 'hexagramMarkerTemplate', value);
				}
			},
			/// <field type="Number">
			/// Sets or gets the top margin to use around the chart content in the canvas.
			/// </field>
			topMargin: {
				get: function () {
					return $(this._element).igDataChart('option', 'topMargin');
				},
				set: function (value) {
					$(this._element).igDataChart('option', 'topMargin', value);
				}
			},
			/// <field type="Number">
			/// Sets or gets the left margin to use around the chart content in the canvas.
			/// </field>
			leftMargin: {
				get: function () {
					return $(this._element).igDataChart('option', 'leftMargin');
				},
				set: function (value) {
					$(this._element).igDataChart('option', 'leftMargin', value);
				}
			},
			/// <field type="Number">
			/// Sets or gets the right margin to use around the chart content in the canvas.
			/// </field>
			rightMargin: {
				get: function () {
					return $(this._element).igDataChart('option', 'rightMargin');
				},
				set: function (value) {
					$(this._element).igDataChart('option', 'rightMargin', value);
				}
			},
			/// <field type="Number">
			/// Sets or gets the bottom margin to use around the chart content in the canvas.
			/// </field>
			bottomMargin: {
				get: function () {
					return $(this._element).igDataChart('option', 'bottomMargin');
				},
				set: function (value) {
					$(this._element).igDataChart('option', 'bottomMargin', value);
				}
			},
			/// <field type="Number">
			/// Sets or gets the automatic width to add when automatically adding margins to the chart.
			/// </field>
			autoMarginWidth: {
				get: function () {
					return $(this._element).igDataChart('option', 'autoMarginWidth');
				},
				set: function (value) {
					$(this._element).igDataChart('option', 'autoMarginWidth', value);
				}
			},
			/// <field type="Number">
			/// Sets or gets the automatic height to add when automatically adding margins to the chart.
			/// </field>
			autoMarginHeight: {
				get: function () {
					return $(this._element).igDataChart('option', 'autoMarginHeight');
				},
				set: function (value) {
					$(this._element).igDataChart('option', 'autoMarginHeight', value);
				}
			},
			/// <field type="Bool">
			/// Gets or sets whether to use a square aspect ratio for the chart. This is locked to true for polar and radial charts.
			/// </field>
			isSquare: {
				get: function () {
					return $(this._element).igDataChart('option', 'isSquare');
				},
				set: function (value) {
					$(this._element).igDataChart('option', 'isSquare', value);
				}
			},
			/// <field type="Enumeration">
			///  Gets or sets the GridMode property.
			/// </field>
			gridMode: {
				get: function () {
					return $(this._element).igDataChart('option', 'gridMode');
				},
				set: function (value) {
					$(this._element).igDataChart('option', 'gridMode', value);
				}
			},
			/// <field type="Object">
			/// Gets or sets the Brushes property.
			/// The brushes property defines the palette from which automatically assigned series brushes are selected.
			/// The value provided should be an array of css color strings. Optionally the first element can be a string reading "RGB" or "HSV" to specify the interpolation mode of the collection.
			/// </field>
			brushes: {
				get: function () {
					return $(this._element).igDataChart('option', 'brushes');
				},
				set: function (value) {
					$(this._element).igDataChart('option', 'brushes', value);
				}
			},
			/// <field type="Object">
			/// Gets or sets the MarkerBrushes property.
			/// The marker brushes property defines the palette from which automatically assigned marker brushes are selected.
			/// The value provided should be an array of css color strings. Optionally the first element can be a string reading "RGB" or "HSV" to specify the interpolation mode of the collection.
			/// </field>
			markerBrushes: {
				get: function () {
					return $(this._element).igDataChart('option', 'markerBrushes');
				},
				set: function (value) {
					$(this._element).igDataChart('option', 'markerBrushes', value);
				}
			},
			/// <field type="Object">
			/// Gets or sets the Outlines property.
			/// The outlines property defines the palette from which automatically assigned series outlines are selected.
			/// The value provided should be an array of css color strings. Optionally the first element can be a string reading "RGB" or "HSV" to specify the interpolation mode of the collection.
			/// </field>
			outlines: {
				get: function () {
					return $(this._element).igDataChart('option', 'outlines');
				},
				set: function (value) {
					$(this._element).igDataChart('option', 'outlines', value);
				}
			},
			/// <field type="Object">
			/// Gets or sets the MarkerOutlines property.
			/// The marker outlines property defines the palette from which automatically assigned marker outlines are selected.
			/// The value provided should be an array of css color strings. Optionally the first element can be a string reading "RGB" or "HSV" to specify the interpolation mode of the collection.
			/// </field>
			markerOutlines: {
				get: function () {
					return $(this._element).igDataChart('option', 'markerOutlines');
				},
				set: function (value) {
					$(this._element).igDataChart('option', 'markerOutlines', value);
				}
			},
			/// <field type="Enumeration">
			///  The width of the chart.
			/// </field>
			width: {
				get: function () {
					return $(this._element).igDataChart('option', 'width');
				},
				set: function (value) {
					$(this._element).igDataChart('option', 'width', value);
				}
			},
			/// <field type="Enumeration">
			///  The height of the chart.
			/// </field>
			height: {
				get: function () {
					return $(this._element).igDataChart('option', 'height');
				},
				set: function (value) {
					$(this._element).igDataChart('option', 'height', value);
				}
			},
			/// <field type="Object">
			/// To set both dimensions of the chart simultaneously an object with a width and height property can be provided
			/// </field>
			size: {
				get: function () {
					return $(this._element).igDataChart('option', 'size');
				},
				set: function (value) {
					$(this._element).igDataChart('option', 'size', value);
				}
			},
			/// <field type="Object">
			/// can be any valid data source accepted by $.ig.DataSource, or an instance of an $.ig.DataSource itself
			/// </field>
			dataSource: {
				get: function () {
					return $(this._element).igDataChart('option', 'dataSource');
				},
				set: function (value) {
					$(this._element).igDataChart('option', 'dataSource', value);
				}
			},
			/// <field type="String">
			/// Specifies a remote URL accepted by $.ig.DataSource in order to request data from it
			/// </field>
			dataSourceUrl: {
				get: function () {
					return $(this._element).igDataChart('option', 'dataSourceUrl');
				},
				set: function (value) {
					$(this._element).igDataChart('option', 'dataSourceUrl', value);
				}
			},
			/// <field type="String">
			/// Explicitly set data source type (such as "json"). Please refer to the documentation of $.ig.DataSource and its type property.
			/// </field>
			dataSourceType: {
				get: function () {
					return $(this._element).igDataChart('option', 'dataSourceType');
				},
				set: function (value) {
					$(this._element).igDataChart('option', 'dataSourceType', value);
				}
			},
			/// <field type="Enumeration">
			///  see $.ig.DataSource. 
			/// </field>
			responseDataKey: {
				get: function () {
					return $(this._element).igDataChart('option', 'responseDataKey');
				},
				set: function (value) {
					$(this._element).igDataChart('option', 'responseDataKey', value);
				}
			},
			/// <field type="String">
			/// string Explicitly set data source type (such as "json"). Please refer to the documentation of $.ig.DataSource and its type property. null Option is ignored.
			/// </field>
			responseDataType: {
				get: function () {
					return $(this._element).igDataChart('option', 'responseDataType');
				},
				set: function (value) {
					$(this._element).igDataChart('option', 'responseDataType', value);
				}
			},
			/// <field type="Object">
			/// can be any valid options accepted by $.ig.ChartLegend, or an instance of an $.ig.ChartLegend itself.
			/// </field>
			legend: {
				get: function () {
					return $(this._element).igDataChart('option', 'legend');
				},
				set: function (value) {
					$(this._element).igDataChart('option', 'legend', value);
				}
			},
			/// <field type="Array">
			/// an array of axis objects
			/// </field>
			axes: {
				get: function () {
					return $(this._element).igDataChart('option', 'axes');
				},
				set: function (value) {
					$(this._element).igDataChart('option', 'axes', value);
				}
			},
			/// <field type="Array">
			/// an array of series objects
			/// </field>
			series: {
				get: function () {
					return $(this._element).igDataChart('option', 'series');
				},
				set: function (value) {
					$(this._element).igDataChart('option', 'series', value);
				}
			},
			/// <field type="String">
			/// The swatch used to style this widget
			/// </field>
			theme: {
				get: function () {
					return $(this._element).igDataChart('option', 'theme');
				},
				set: function (value) {
					$(this._element).igDataChart('option', 'theme', value);
				}
			},

			// Public methods
			/*
			destroy: function igDataChart_destroy() {
				$(this._element).igDataChart('destroy');
			}
			*/
						/* Returns the element holding the chart.
			*/
            widget: function DataChart_widget () {
                $(this._element).igDataChart('widget');
            },
			/* returns the ID of parent element holding the chart.
			*/
            id: function DataChart_id () {
                $(this._element).igDataChart('id');
            },
			/* Exports the chart to a PNG image.
			*/
            exportImage: function DataChart_exportImage (width, height) {
                $(this._element).igDataChart('exportImage', width, height);
            },
			/* Destroys the widget.
			*/
            destroy: function DataChart_destroy () {
                $(this._element).igDataChart('destroy');
            },
			/* Notify the chart that styles it draws colors from may have been updated.
			*/
            styleUpdated: function DataChart_styleUpdated () {
                $(this._element).igDataChart('styleUpdated');
            },
			/* Resets the zoom level of the chart to default.
			*/
            resetZoom: function DataChart_resetZoom () {
                $(this._element).igDataChart('resetZoom');
            },
			/* adds a new item to the data source and notifies the chart.
			*/
            addItem: function DataChart_addItem (item, targetName) {
                $(this._element).igDataChart('addItem', item, targetName);
            },
			/* inserts a new item to the data source and notifies the chart.
			*/
            insertItem: function DataChart_insertItem (item, index, targetName) {
                $(this._element).igDataChart('insertItem', item, index, targetName);
            },
			/* deletes an item from the data source and notifies the chart.
			*/
            removeItem: function DataChart_removeItem (index, targetName) {
                $(this._element).igDataChart('removeItem', index, targetName);
            },
			/* updates an item in the data source and notifies the chart.
			*/
            setItem: function DataChart_setItem (index, item, targetName) {
                $(this._element).igDataChart('setItem', index, item, targetName);
            },
			/* Notifies the chart that an item has been set in an associated data source.
			*/
            notifySetItem: function DataChart_notifySetItem (dataSource, index, newItem, oldItem) {
                $(this._element).igDataChart('notifySetItem', dataSource, index, newItem, oldItem);
            },
			/* Notifies the chart that the items have been cleared from an associated data source.
It's not necessary to notify more than one target of a change if they share the same items source.
			*/
            notifyClearItems: function DataChart_notifyClearItems (dataSource) {
                $(this._element).igDataChart('notifyClearItems', dataSource);
            },
			/* Notifies the target axis or series that an item has been inserted at the specified index in its data source.
It's not necessary to notify more than one target of a change if they share the same items source.
			*/
            notifyInsertItem: function DataChart_notifyInsertItem (dataSource, index, newItem) {
                $(this._element).igDataChart('notifyInsertItem', dataSource, index, newItem);
            },
			/* Notifies the target axis or series that an item has been removed from the specified index in its data source.
It's not necessary to notify more than one target of a change if they share the same items source.
			*/
            notifyRemoveItem: function DataChart_notifyRemoveItem (dataSource, index, oldItem) {
                $(this._element).igDataChart('notifyRemoveItem', dataSource, index, oldItem);
            },
			/* Notifies the target axis or series that it should scroll the requested data item into view.
			*/
            scrollIntoView: function DataChart_scrollIntoView (targetName, item) {
                $(this._element).igDataChart('scrollIntoView', targetName, item);
            },
			/* Notifies the target axis that it should scale the requested value into chart space from axis space.
			*/
            scaleValue: function DataChart_scaleValue (targetName, unscaledValue) {
                $(this._element).igDataChart('scaleValue', targetName, unscaledValue);
            },
			/* Notifies the target axis that it should unscale the requested value into axis space from chart space.
			*/
            unscaleValue: function DataChart_unscaleValue (targetName, scaledValue) {
                $(this._element).igDataChart('unscaleValue', targetName, scaledValue);
            },
			/* Forces any pending deferred work to render on the chart before continuing
			*/
            flush: function DataChart_flush () {
                $(this._element).igDataChart('flush');
            },
			/* exports visual data from the chart to aid in unit testing
			*/
            exportVisualData: function DataChart_exportVisualData () {
                $(this._element).igDataChart('exportVisualData');
            },
			/* Gets the actual minimum value of the target numeric or date time axis
			*/
            getActualMinimumValue: function DataChart_getActualMinimumValue (targetName) {
                $(this._element).igDataChart('getActualMinimumValue', targetName);
            },
			/* Gets the actual maximum value of the target numeric or date time axis
			*/
            getActualMaximumValue: function DataChart_getActualMaximumValue (targetName) {
                $(this._element).igDataChart('getActualMaximumValue', targetName);
            },
			/* 
			*/
            print: function DataChart_print () {
                $(this._element).igDataChart('print');
            },
			/* Indicates that a series should render, even though no option has been modified that would normally cause it to refresh.
			*/
            renderSeries: function DataChart_renderSeries (targetName, animate) {
                $(this._element).igDataChart('renderSeries', targetName, animate);
            },
			/* Notifies the chart that the container was resized
			*/
            notifyContainerResized: function DataChart_notifyContainerResized () {
                $(this._element).igDataChart('notifyContainerResized');
            }

        }, {
			// Static members
		})
    });
}());