// igDatePicker extension
/*global WinJS, $*/
(function () {
    WinJS.Namespace.define('Infragistics.UI', {
        DatePicker: WinJS.Class.define(function (element, options) {
			// This needs to be defined for all widgets
            if (!element) {
                throw new Error("The Infragistics control requires a DOM element to be instantiated on.");
            }
			this._element = element;
			// Initializes the control
			MSApp.execUnsafeLocalFunction(function () {
				$(element).igDatePicker(options);
			});
			this.element.winControl = this;
        }, {
			// Private properties
			_element: null,
            // Public options
			// The element option is generic for all widget and is only a getter
			element: {
                get: function () {
                    return this._element;
                }
            },
						/// <field type="Enumeration">
			///  Sets gets visibility of spin and drop-down button.
			/// </field>
			button: {
				get: function () {
					return $(this._element).igDatePicker('option', 'button');
				},
				set: function (value) {
					$(this._element).igDatePicker('option', 'button', value);
				}
			},
			/// <field type="Object">
			/// Sets gets options supported by the jquery.ui.datepicker.
			/// </field>
			datepickerOptions: {
				get: function () {
					return $(this._element).igDatePicker('option', 'datepickerOptions');
				},
				set: function (value) {
					$(this._element).igDatePicker('option', 'datepickerOptions', value);
				}
			},

			// Public methods
			/*
			destroy: function igDatePicker_destroy() {
				$(this._element).igDatePicker('destroy');
			}
			*/
			
        }, {
			// Static members
		})
    });
}());