// Grid extension
/*global WinJS, $*/
(function () {
    WinJS.Namespace.define('Infragistics.UI', {
        Grid: WinJS.Class.define(function (element, options) {
            if (!element) {
                throw new Error("The Infragistics WinJS Grid control needs a DOM element to be instantiated on.");
            }
            this._element = element;
            MSApp.execUnsafeLocalFunction( function () {
                $(element).igGrid(options);
            });
            this.element.winControl = this;
        }, {
            // Private Fields
            _element: null,
            _grid: null,
            // Public Options
            element: {
                get: function () {
                    return this._element;
                }
            },
            /// <field type="Number">
            /// Sets the Infragistics Grid width
            /// </field>
            width: {
                get: function () {
                    return $(this._element).igGrid('option', 'width');
                },
                set: function (value) {
                    $(this._element).igGrid('option', 'width', value);
                }
            },
            /// <field type="Number">
            /// Sets the Infragistics Grid height
            /// </field>
            height: {
                get: function () {
                    return $(this._element).igGrid('option', 'height');
                },
                set: function (value) {
                    $(this._element).igGrid('option', 'height', value);
                }
            },
            /// <field type="Boolean">
            /// Enables / disables auto adjustment of height in the Infragistics Grid
            /// </field>
            autoAdjustHeight: {
                get: function () {
                    return $(this._element).igGrid('option', 'autoAdjustHeight');
                },
                set: function (value) {
                    $(this._element).igGrid('option', 'autoAdjustHeight', value);
                }
            },
            /// <field type="Number">
            /// Sets the Infragistics Grid average row height
            /// </field>
            avgRowHeight: {
                get: function () {
                    return $(this._element).igGrid('option', 'avgRowHeight');
                },
                set: function (value) {
                    $(this._element).igGrid('option', 'avgRowHeight', value);
                }
            },
            /// <field type="Number">
            /// Sets the Infragistics Grid average column width
            /// </field>
            avgColumnWidth: {
                get: function () {
                    return $(this._element).igGrid('option', 'avgColumnWidth');
                },
                set: function (value) {
                    $(this._element).igGrid('option', 'avgColumnWidth', value);
                }
            },
            /// <field type="Number">
            /// Sets the Infragistics Grid default column width
            /// </field>
            defaultColumnWidth: {
                get: function () {
                    return $(this._element).igGrid('option', 'defaultColumnWidth');
                },
                set: function (value) {
                    $(this._element).igGrid('option', 'defaultColumnWidth', value);
                }
            },
            /// <field type="Boolean">
            /// enables / disables virtualization
            /// </field>
            virtualization: {
                get: function () {
                    return $(this._element).igGrid('option', 'virtualization');
                },
                set: function (value) {
                    $(this._element).igGrid('option', 'virtualization', value);
                }
            },
            /// <field type="Boolean">
            /// enables / disables autoGenerateColumns
            /// </field>
            autoGenerateColumns: {
                get: function () {
                    return $(this._element).igGrid('option', 'autoGenerateColumns');
                },
                set: function (value) {
                    $(this._element).igGrid('option', 'autoGenerateColumns', value);
                }
            },
            /// <field type="String">
            /// Sets the Infragistics Grid virtualization mode
            /// </field>
            virtualizationMode: {
                get: function () {
                    return $(this._element).igGrid('option', 'virtualizationMode');
                },
                set: function (value) {
                    $(this._element).igGrid('option', 'virtualizationMode', value);
                }
            },
            /// <field type="Boolean">
            /// Indicates whether the Infragistics grid requires to undergo databinding
            /// </field>
            requiresDataBinding: {
                get: function () {
                    return $(this._element).igGrid('option', 'requiresDataBinding');
                },
                set: function (value) {
                    $(this._element).igGrid('option', 'requiresDataBinding', value);
                }
            },
            /// <field type="Boolean">
            /// Enables / disables row virtualization for the Infragistics Grid
            /// </field>
            rowVirtualization: {
                get: function () {
                    return $(this._element).igGrid('option', 'rowVirtualization');
                },
                set: function (value) {
                    $(this._element).igGrid('option', 'rowVirtualization', value);
                }
            },
            /// <field type="Boolean">
            /// Enables / disables column virtualization for the Infragistics Grid
            /// </field>
            columnVirtualization: {
                get: function () {
                    return $(this._element).igGrid('option', 'columnVirtualization');
                },
                set: function (value) {
                    $(this._element).igGrid('option', 'columnVirtualization', value);
                }
            },
            /// <field type="Number">
            /// Sets the Infragistics Grid virtualization mouse wheel step
            /// </field>
            virtualizationMouseWheelStep: {
                get: function () {
                    return $(this._element).igGrid('option', 'virtualizationMouseWheelStep');
                },
                set: function (value) {
                    $(this._element).igGrid('option', 'virtualizationMouseWheelStep', value);
                }
            },
            /// <field type="Boolean">
            /// Adjusts the Infragistics Grid virtualization row height automatically
            /// </field>
            adjustVirtualHeights: {
                get: function () {
                    return $(this._element).igGrid('option', 'adjustVirtualHeights');
                },
                set: function (value) {
                    $(this._element).igGrid('option', 'adjustVirtualHeights', value);
                }
            },
            /// <field type="String">
            /// Sets the Infragistics Grid row template
            /// </field>
            rowTemplate: {
                get: function () {
                    return $(this._element).igGrid('option', 'rowTemplate');
                },
                set: function (value) {
                    $(this._element).igGrid('option', 'rowTemplate', value);
                }
            },
            /// <field type="Boolean">
            /// Enables / disables the Infragistics Grid header
            /// </field>
            showHeader: {
                get: function () {
                    return $(this._element).igGrid('option', 'showHeader');
                },
                set: function (value) {
                    $(this._element).igGrid('option', 'showHeader', value);
                }
            },
            /// <field type="Boolean">
            /// Enables / disables the Infragistics Grid footer
            /// </field>
            showFooter: {
                get: function () {
                    return $(this._element).igGrid('option', 'showFooter');
                },
                set: function (value) {
                    $(this._element).igGrid('option', 'showFooter', value);
                }
            },
            /// <field type="Boolean">
            /// Enables / disables the Infragistics Grid fixed headers
            /// </field>
            fixedHeaders: {
                get: function () {
                    return $(this._element).igGrid('option', 'fixedHeaders');
                },
                set: function (value) {
                    $(this._element).igGrid('option', 'fixedHeaders', value);
                }
            },
            /// <field type="Boolean">
            /// Enables / disables the Infragistics Grid fixed footers
            /// </field>
            fixedFooters: {
                get: function () {
                    return $(this._element).igGrid('option', 'fixedFooters');
                },
                set: function (value) {
                    $(this._element).igGrid('option', 'fixedFooters', value);
                }
            },
            /// <field type="String">
            /// Sets the Infragistics Grid caption
            /// </field>
            caption: {
                get: function () {
                    return $(this._element).igGrid('option', 'caption');
                },
                set: function (value) {
                    $(this._element).igGrid('option', 'caption', value);
                }
            },
            /// <field type="Object">
            /// Enables / disables features of the Infragistics Grid
            /// </field>
            features: {
                get: function () {
                    return $(this._element).igGrid('option', 'features');
                },
                set: function (value) {
                    $(this._element).igGrid('option', 'features', value);
                }
            },
            /// <field type="Number">
            /// Sets the Infragistics Grid container tab index
            /// </field>
            tabIndex: {
                get: function () {
                    return $(this._element).igGrid('option', 'tabIndex');
                },
                set: function (value) {
                    $(this._element).igGrid('option', 'tabIndex', value);
                }
            },
            /// <field type="Boolean">
            /// Enables / disables the Infragistics Grid accesibility mode rendering
            /// </field>
            accessibilityRendering: {
                get: function () {
                    return $(this._element).igGrid('option', 'accessibilityRendering');
                },
                set: function (value) {
                    $(this._element).igGrid('option', 'accessibilityRendering', value);
                }
            },
            /// <field type="Boolean">
            /// Enables / disables the Infragistics Grid data source schemal transformation
            /// </field>
            localSchemaTransform: {
                get: function () {
                    return $(this._element).igGrid('option', 'localSchemaTransform');
                },
                set: function (value) {
                    $(this._element).igGrid('option', 'localSchemaTransform', value);
                }
            },
            /// <field type="String">
            /// Indicates the name (column key) of the column which holds the primary key attribute for the data source
            /// </field>
            primaryKey: {
                get: function () {
                    return $(this._element).igGrid('option', 'primaryKey');
                },
                set: function (value) {
                    $(this._element).igGrid('option', 'primaryKey', value);
                }
            },
            /// <field type="String">
            /// Sets the auto formatting for the Infragistics Grid fields
            /// </field>
            autoFormat: {
                get: function () {
                    return $(this._element).igGrid('option', 'autoFormat');
                },
                set: function (value) {
                    $(this._element).igGrid('option', 'autoFormat', value);
                }
            },
            /// <field type="Boolean">
            /// Enables / disables rendering of checkboxes in the boolean fields of the Infragistics Grid
            /// </field>
            renderCheckboxes: {
                get: function () {
                    return $(this._element).igGrid('option', 'renderCheckboxes');
                },
                set: function (value) {
                    $(this._element).igGrid('option', 'renderCheckboxes', value);
                }
            },
            /// <field type="Boolean">
            /// Enables / disables alternating row style for the Infragistics Grid
            /// </field>
            alternateRowStyle: {
                get: function () {
                    return $(this._element).igGrid('option', 'alternateRowStyle');
                },
                set: function (value) {
                    $(this._element).igGrid('option', 'alternateRowStyle', value);
                }
            },
            /// <field type="Boolean">
            /// Enables / disables auto fitting of the last column inside the Infragistics Grid if all other columns have specified
            /// width less than the total grid width
            /// </field>
            autofitLastColumn: {
                get: function () {
                    return $(this._element).igGrid('option', 'autofitLastColumn');
                },
                set: function (value) {
                    $(this._element).igGrid('option', 'autofitLastColumn', value);
                }
            },
            /// <field type="Boolean">
            /// Enables / disables hover styles for the Infragistics Grid
            /// </field>
            enableHoverStyles: {
                get: function () {
                    return $(this._element).igGrid('option', 'enableHoverStyles');
                },
                set: function (value) {
                    $(this._element).igGrid('option', 'enableHoverStyles', value);
                }
            },
            /// <field type="Boolean">
            /// Enables / disables UTC dates for the Infragistics Grid
            /// </field>
            enableUTCDates: {
                get: function () {
                    return $(this._element).igGrid('option', 'enableUTCDates');
                },
                set: function (value) {
                    $(this._element).igGrid('option', 'enableUTCDates', value);
                }
            },
            /// <field type="Boolean">
            /// Enables / disables the merging of unbound columns for the Infragistics Grid
            /// </field>
            mergeUnboundColumns: {
                get: function () {
                    return $(this._element).igGrid('option', 'mergeUnboundColumns');
                },
                set: function (value) {
                    $(this._element).igGrid('option', 'mergeUnboundColumns', value);
                }
            },
            /// <field type="Object">
            /// Sets the Infragistics Grid data source
            /// </field>
            dataSource: {
                get: function () {
                    return $(this._element).igGrid('option', 'dataSource');
                },
                set: function (value) {
                    $(this._element).igGrid('option', 'dataSource', value);
                }
            },
            // Public methods
            dataBind: function Grid_dataBind() {
                $(this._element).igGrid('dataBind');
            },
            destroy: function Grid_destroy() {
                $(this._element).igGrid('destroy');
            }
        })
    });
}());