// igMap extension
/*global WinJS, $*/
(function () {
    WinJS.Namespace.define('Infragistics.UI', {
        Map: WinJS.Class.define(function (element, options) {
			// This needs to be defined for all widgets
            if (!element) {
                throw new Error("The Infragistics control requires a DOM element to be instantiated on.");
            }
			this._element = element;
            // Initializes the control
			MSApp.execUnsafeLocalFunction(function () {
			    $(element).igMap(options);
			});
			this.element.winControl = this;
        }, {
			// Private properties
			_element: null,
            // Public options
			// The element option is generic for all widget and is only a getter
			element: {
                get: function () {
                    return this._element;
                }
            },
						/// <field type="Number">
			/// The width of the map. It can be set as a number in pixels, string (px) or percentage (%).
			/// </field>
			width: {
				get: function () {
					return $(this._element).igMap('option', 'width');
				},
				set: function (value) {
					$(this._element).igMap('option', 'width', value);
				}
			},
			/// <field type="Number">
			/// The height of the map. It can be set as a number in pixels, string (px) or percentage (%).
			/// </field>
			height: {
				get: function () {
					return $(this._element).igMap('option', 'height');
				},
				set: function (value) {
					$(this._element).igMap('option', 'height', value);
				}
			},
			/// <field type="Object">
			/// can be any valid data source accepted by $.ig.DataSource, or an instance of an $.ig.DataSource itself
			/// </field>
			dataSource: {
				get: function () {
					return $(this._element).igMap('option', 'dataSource');
				},
				set: function (value) {
					$(this._element).igMap('option', 'dataSource', value);
				}
			},
			/// <field type="String">
			/// Specifies a remote URL accepted by $.ig.DataSource in order to request data from it
			/// </field>
			dataSourceUrl: {
				get: function () {
					return $(this._element).igMap('option', 'dataSourceUrl');
				},
				set: function (value) {
					$(this._element).igMap('option', 'dataSourceUrl', value);
				}
			},
			/// <field type="String">
			/// Explicitly set data source type (such as "json"). Please refer to the documentation of $.ig.DataSource and its type property.
			/// </field>
			dataSourceType: {
				get: function () {
					return $(this._element).igMap('option', 'dataSourceType');
				},
				set: function (value) {
					$(this._element).igMap('option', 'dataSourceType', value);
				}
			},
			/// <field type="String">
			/// see $.ig.DataSource. Specifies the name of the property in which data records are held if the response is wrapped.
			/// </field>
			responseDataKey: {
				get: function () {
					return $(this._element).igMap('option', 'responseDataKey');
				},
				set: function (value) {
					$(this._element).igMap('option', 'responseDataKey', value);
				}
			},
			/// <field type="Number">
			/// Sets or gets the automatic width to add when automatically adding margins to the map.
			/// </field>
			autoMarginWidth: {
				get: function () {
					return $(this._element).igMap('option', 'autoMarginWidth');
				},
				set: function (value) {
					$(this._element).igMap('option', 'autoMarginWidth', value);
				}
			},
			/// <field type="Number">
			/// Sets or gets the automatic height to add when automatically adding margins to the map.
			/// </field>
			autoMarginHeight: {
				get: function () {
					return $(this._element).igMap('option', 'autoMarginHeight');
				},
				set: function (value) {
					$(this._element).igMap('option', 'autoMarginHeight', value);
				}
			},
			/// <field type="Enumeration">
			///  Gets or sets the current Map's crosshair visibility override.
			/// </field>
			crosshairVisibility: {
				get: function () {
					return $(this._element).igMap('option', 'crosshairVisibility');
				},
				set: function (value) {
					$(this._element).igMap('option', 'crosshairVisibility', value);
				}
			},
			/// <field type="Object">
			/// Gets or sets the cross hair point (in world coordinates)
///			Either or both of the crosshair point's X and Y may be set to double.NaN, in which
///			case the relevant crosshair line is hidden.
			/// </field>
			crosshairPoint: {
				get: function () {
					return $(this._element).igMap('option', 'crosshairPoint');
				},
				set: function (value) {
					$(this._element).igMap('option', 'crosshairPoint', value);
				}
			},
			/// <field type="String">
			/// Gets or sets the brush used as the background for the current Map object's plot area.
			/// </field>
			plotAreaBackground: {
				get: function () {
					return $(this._element).igMap('option', 'plotAreaBackground');
				},
				set: function (value) {
					$(this._element).igMap('option', 'plotAreaBackground', value);
				}
			},
			/// <field type="Enumeration">
			///  Gets or sets the DefaultInteraction property. The default interaction state defines the map's response to mouse events.
			/// </field>
			defaultInteraction: {
				get: function () {
					return $(this._element).igMap('option', 'defaultInteraction');
				},
				set: function (value) {
					$(this._element).igMap('option', 'defaultInteraction', value);
				}
			},
			/// <field type="Enumeration">
			///  Gets or sets the current Map's DragModifier property.
			/// </field>
			dragModifier: {
				get: function () {
					return $(this._element).igMap('option', 'dragModifier');
				},
				set: function (value) {
					$(this._element).igMap('option', 'dragModifier', value);
				}
			},
			/// <field type="Enumeration">
			///  Gets or sets the current Map's PanModifier property.
			/// </field>
			panModifier: {
				get: function () {
					return $(this._element).igMap('option', 'panModifier');
				},
				set: function (value) {
					$(this._element).igMap('option', 'panModifier', value);
				}
			},
			/// <field type="Object">
			/// Gets or sets the preview rectangle.
///			The preview rectangle may be set to Rect.Empty, in which case the visible preview
///			strokePath is hidden.
///			The provided object should have numeric properties called left, top, width and height.
			/// </field>
			previewRect: {
				get: function () {
					return $(this._element).igMap('option', 'previewRect');
				},
				set: function (value) {
					$(this._element).igMap('option', 'previewRect', value);
				}
			},
			/// <field type="Object">
			/// A rectangle representing the portion of the map currently in view.
///			A rectangle at X=0, Y=0 with a Height and Width of 1 implies the entire plotting area is in view.  A Height and Width of .5 would imply that the view is halfway zoomed in.
///			The provided object should have numeric properties called left, top, width and height.
			/// </field>
			windowRect: {
				get: function () {
					return $(this._element).igMap('option', 'windowRect');
				},
				set: function (value) {
					$(this._element).igMap('option', 'windowRect', value);
				}
			},
			/// <field type="Bool">
			/// Gets or sets the current Map's horizontal zoomability.
			/// </field>
			horizontalZoomable: {
				get: function () {
					return $(this._element).igMap('option', 'horizontalZoomable');
				},
				set: function (value) {
					$(this._element).igMap('option', 'horizontalZoomable', value);
				}
			},
			/// <field type="Bool">
			/// Gets or sets the current Map's vertical zoomability.
			/// </field>
			verticalZoomable: {
				get: function () {
					return $(this._element).igMap('option', 'verticalZoomable');
				},
				set: function (value) {
					$(this._element).igMap('option', 'verticalZoomable', value);
				}
			},
			/// <field type="Enumeration">
			/// 
			/// </field>
			windowResponse: {
				get: function () {
					return $(this._element).igMap('option', 'windowResponse');
				},
				set: function (value) {
					$(this._element).igMap('option', 'windowResponse', value);
				}
			},
			/// <field type="Number">
			/// Sets or gets the minimum width that the window rect is allowed to reach before being clamped.
///			Decrease this value if you want to allow for further zooming into the viewer.
///			If this value is lowered too much it can cause graphical corruption due to floating point arithmetic inaccuracy.
			/// </field>
			windowRectMinWidth: {
				get: function () {
					return $(this._element).igMap('option', 'windowRectMinWidth');
				},
				set: function (value) {
					$(this._element).igMap('option', 'windowRectMinWidth', value);
				}
			},
			/// <field type="Number">
			/// A number between 0 and 1 determining the position of the horizontal scroll.
///			This property is effectively a shortcut to the X position of the WindowRect property.
			/// </field>
			windowPositionHorizontal: {
				get: function () {
					return $(this._element).igMap('option', 'windowPositionHorizontal');
				},
				set: function (value) {
					$(this._element).igMap('option', 'windowPositionHorizontal', value);
				}
			},
			/// <field type="Number">
			/// A number between 0 and 1 determining the position of the vertical scroll.
///			This property is effectively a shortcut to the Y position of the WindowRect property.
			/// </field>
			windowPositionVertical: {
				get: function () {
					return $(this._element).igMap('option', 'windowPositionVertical');
				},
				set: function (value) {
					$(this._element).igMap('option', 'windowPositionVertical', value);
				}
			},
			/// <field type="Object">
			/// Gets or sets the template to use for circle markers on the map.
///			Defines the marker template used for
///			series with a marker type of circle.
///			The provided object should have properties called render and optionally measure. See definition for option: legendItemBadgeTemplate
			/// </field>
			circleMarkerTemplate: {
				get: function () {
					return $(this._element).igMap('option', 'circleMarkerTemplate');
				},
				set: function (value) {
					$(this._element).igMap('option', 'circleMarkerTemplate', value);
				}
			},
			/// <field type="Object">
			/// Gets or sets the template to use for triangle markers on the map.
///			Defines the marker template used for
///			series with a marker type of triangle.
///			The provided object should have properties called render and optionally measure. See definition for option: legendItemBadgeTemplate
			/// </field>
			triangleMarkerTemplate: {
				get: function () {
					return $(this._element).igMap('option', 'triangleMarkerTemplate');
				},
				set: function (value) {
					$(this._element).igMap('option', 'triangleMarkerTemplate', value);
				}
			},
			/// <field type="Object">
			/// Gets or sets the template to use for pyramid markers on the map.
///			Defines the marker template used for
///			series with a marker type of pyramid.
///			The provided object should have properties called render and optionally measure. See definition for option: legendItemBadgeTemplate
			/// </field>
			pyramidMarkerTemplate: {
				get: function () {
					return $(this._element).igMap('option', 'pyramidMarkerTemplate');
				},
				set: function (value) {
					$(this._element).igMap('option', 'pyramidMarkerTemplate', value);
				}
			},
			/// <field type="Object">
			/// Gets or sets the template to use for square markers on the map.
///			Defines the marker template used for
///			series with a marker type of square.
///			The provided object should have properties called render and optionally measure. See definition for option: legendItemBadgeTemplate
			/// </field>
			squareMarkerTemplate: {
				get: function () {
					return $(this._element).igMap('option', 'squareMarkerTemplate');
				},
				set: function (value) {
					$(this._element).igMap('option', 'squareMarkerTemplate', value);
				}
			},
			/// <field type="Object">
			/// Gets or sets the template to use for diamond markers on the map.
///			Defines the marker template used for
///			series with a marker type of diamond.
///			The provided object should have properties called render and optionally measure. See definition for option: legendItemBadgeTemplate
			/// </field>
			diamondMarkerTemplate: {
				get: function () {
					return $(this._element).igMap('option', 'diamondMarkerTemplate');
				},
				set: function (value) {
					$(this._element).igMap('option', 'diamondMarkerTemplate', value);
				}
			},
			/// <field type="Object">
			/// Gets or sets the template to use for pentagon markers on the map.
///			Defines the marker template used for
///			series with a marker type of pentagon.
///			The provided object should have properties called render and optionally measure. See definition for option: legendItemBadgeTemplate
			/// </field>
			pentagonMarkerTemplate: {
				get: function () {
					return $(this._element).igMap('option', 'pentagonMarkerTemplate');
				},
				set: function (value) {
					$(this._element).igMap('option', 'pentagonMarkerTemplate', value);
				}
			},
			/// <field type="Object">
			/// Gets or sets the template to use for hexagon markers on the map.
///			Defines the marker template used for
///			series with a marker type of hexagon.
///			The provided object should have properties called render and optionally measure. See definition for option: legendItemBadgeTemplate
			/// </field>
			hexagonMarkerTemplate: {
				get: function () {
					return $(this._element).igMap('option', 'hexagonMarkerTemplate');
				},
				set: function (value) {
					$(this._element).igMap('option', 'hexagonMarkerTemplate', value);
				}
			},
			/// <field type="Object">
			/// Gets or sets the template to use for tetragram markers on the map.
///			Defines the marker template used for
///			series with a marker type of tetragram.
///			The provided object should have properties called render and optionally measure. See definition for option: legendItemBadgeTemplate
			/// </field>
			tetragramMarkerTemplate: {
				get: function () {
					return $(this._element).igMap('option', 'tetragramMarkerTemplate');
				},
				set: function (value) {
					$(this._element).igMap('option', 'tetragramMarkerTemplate', value);
				}
			},
			/// <field type="Object">
			/// Gets or sets the template to use for pentragram markers on the map.
///			Defines the marker template used for
///			series with a marker type of pentagram.
///			The provided object should have properties called render and optionally measure. See definition for option: legendItemBadgeTemplate
			/// </field>
			pentagramMarkerTemplate: {
				get: function () {
					return $(this._element).igMap('option', 'pentagramMarkerTemplate');
				},
				set: function (value) {
					$(this._element).igMap('option', 'pentagramMarkerTemplate', value);
				}
			},
			/// <field type="Object">
			/// Gets or sets the template to use for hexagram markers on the map.
///			Defines the marker template used for
///			series with a marker type of hexagram.
///			The provided object should have properties called render and optionally measure. See definition for option: legendItemBadgeTemplate
			/// </field>
			hexagramMarkerTemplate: {
				get: function () {
					return $(this._element).igMap('option', 'hexagramMarkerTemplate');
				},
				set: function (value) {
					$(this._element).igMap('option', 'hexagramMarkerTemplate', value);
				}
			},
			/// <field type="String">
			/// The background image uri use in the overview detail pane.
			/// </field>
			overviewPlusDetailPaneBackgroundImageUri: {
				get: function () {
					return $(this._element).igMap('option', 'overviewPlusDetailPaneBackgroundImageUri');
				},
				set: function (value) {
					$(this._element).igMap('option', 'overviewPlusDetailPaneBackgroundImageUri', value);
				}
			},
			/// <field type="Object">
			/// background content object
			/// </field>
			backgroundContent: {
				get: function () {
					return $(this._element).igMap('option', 'backgroundContent');
				},
				set: function (value) {
					$(this._element).igMap('option', 'backgroundContent', value);
				}
			},
			/// <field type="Array">
			/// an array of series objects
			/// </field>
			series: {
				get: function () {
					return $(this._element).igMap('option', 'series');
				},
				set: function (value) {
					$(this._element).igMap('option', 'series', value);
				}
			},

			// Public methods
			/*
			destroy: function igMap_destroy() {
				$(this._element).igMap('destroy');
			}
			*/
						/* Destroys the widget.
			*/
            destroy: function Map_destroy () {
                $(this._element).igMap('destroy');
            },
			/* returns the ID of parent element holding the map.
			*/
            id: function Map_id () {
                $(this._element).igMap('id');
            },
			/* Exports the map to a PNG image.
			*/
            exportImage: function Map_exportImage (width, height) {
                $(this._element).igMap('exportImage', width, height);
            },
			/* Notify the map that styles it draws colors from may have been updated.
			*/
            styleUpdated: function Map_styleUpdated () {
                $(this._element).igMap('styleUpdated');
            },
			/* Resets the zoom level of the map to default.
			*/
            resetZoom: function Map_resetZoom () {
                $(this._element).igMap('resetZoom');
            },
			/* adds a new item to the data source and notifies the map.
			*/
            addItem: function Map_addItem (item, targetName) {
                $(this._element).igMap('addItem', item, targetName);
            },
			/* inserts a new item to the data source and notifies the map.
			*/
            insertItem: function Map_insertItem (item, index, targetName) {
                $(this._element).igMap('insertItem', item, index, targetName);
            },
			/* deletes an item from the data source and notifies the map.
			*/
            removeItem: function Map_removeItem (index, targetName) {
                $(this._element).igMap('removeItem', index, targetName);
            },
			/* updates an item in the data source and notifies the map.
			*/
            setItem: function Map_setItem (index, item, targetName) {
                $(this._element).igMap('setItem', index, item, targetName);
            },
			/* Notifies the the map that an item has been set in an associated data source.
			*/
            notifySetItem: function Map_notifySetItem (dataSource, index, newItem, oldItem) {
                $(this._element).igMap('notifySetItem', dataSource, index, newItem, oldItem);
            },
			/* Notifies the the map that the items have been cleared from an associated data source.
It's not necessary to notify more than one target of a change if they share the same items source.
			*/
            notifyClearItems: function Map_notifyClearItems (dataSource) {
                $(this._element).igMap('notifyClearItems', dataSource);
            },
			/* Notifies the the target series that an item has been inserted at the specified index in its data source.
It's not necessary to notify more than one target of a change if they share the same items source.
			*/
            notifyInsertItem: function Map_notifyInsertItem (dataSource, index, newItem) {
                $(this._element).igMap('notifyInsertItem', dataSource, index, newItem);
            },
			/* Notifies the the target series that an item has been removed from the specified index in its data source.
It's not necessary to notify more than one target of a change if they share the same items source.
			*/
            notifyRemoveItem: function Map_notifyRemoveItem (dataSource, index, oldItem) {
                $(this._element).igMap('notifyRemoveItem', dataSource, index, oldItem);
            },
			/* Notifies the target series or axis that it should scroll the requested data item into view.
			*/
            scrollIntoView: function Map_scrollIntoView (targetName, item) {
                $(this._element).igMap('scrollIntoView', targetName, item);
            },
			/* Either xAxis or yAxis (longitude or latitude) that it should scale the requested value into map space from axis space.
For example you can use this method if you want to find where longitude 50 stands scaled to map's width.
			*/
            scaleValue: function Map_scaleValue (targetName, unscaledValue) {
                $(this._element).igMap('scaleValue', targetName, unscaledValue);
            },
			/* Either xAxis or yAxis (longitude or latitude) that it should unscale the requested value into axis space from map space.
For example you can use this method if you want to find what is the longitude unscaled from 0 width of the map.
			*/
            unscaleValue: function Map_unscaleValue (targetName, scaledValue) {
                $(this._element).igMap('unscaleValue', targetName, scaledValue);
            },
			/* Forces any pending deferred work to render on the map before continuing
			*/
            flush: function Map_flush () {
                $(this._element).igMap('flush');
            },
			/* exports visual data from the map to aid in unit testing
			*/
            exportVisualData: function Map_exportVisualData () {
                $(this._element).igMap('exportVisualData');
            },
			/* Gets the actual minimum value of the target xAxis or yAxis
			*/
            getActualMinimumValue: function Map_getActualMinimumValue (targetName) {
                $(this._element).igMap('getActualMinimumValue', targetName);
            },
			/* Gets the actual maximum value of the target xAxis or yAxis
			*/
            getActualMaximumValue: function Map_getActualMaximumValue (targetName) {
                $(this._element).igMap('getActualMaximumValue', targetName);
            },
			/* Notifies the map that the container was resized
			*/
            notifyContainerResized: function Map_notifyContainerResized () {
                $(this._element).igMap('notifyContainerResized');
            },
			/* Given the current plot area of the control and a geographic region, get the WindowRect that would encompass that geographic region.
			*/
            getGeographicFromZoom: function Map_getGeographicFromZoom (rect) {
                $(this._element).igMap('getGeographicFromZoom', rect);
            },
			/* Given the current plot area of the control and a geographic region, get the WindowRect that would encompass that geographic region.
			*/
            getZoomFromGeographic: function Map_getZoomFromGeographic (rect) {
                $(this._element).igMap('getZoomFromGeographic', rect);
            },
			/* 
			*/
            print: function Map_print () {
                $(this._element).igMap('print');
            },
			/* Indicates that a series should render, even though no option has been modified that would normally cause it to refresh.
			*/
            renderSeries: function Map_renderSeries (targetName, animate) {
                $(this._element).igMap('renderSeries', targetName, animate);
            }

        }, {
			// Static members
		})
    });
}());