// igPercentEditor extension
/*global WinJS, $*/
(function () {
    WinJS.Namespace.define('Infragistics.UI', {
        PercentEditor: WinJS.Class.define(function (element, options) {
			// This needs to be defined for all widgets
            if (!element) {
                throw new Error("The Infragistics control requires a DOM element to be instantiated on.");
            }
			this._element = element;
			// Initializes the control
			MSApp.execUnsafeLocalFunction(function () {
				$(element).igPercentEditor(options);
			});
			this.element.winControl = this;
        }, {
			// Private properties
			_element: null,
            // Public options
			// The element option is generic for all widget and is only a getter
			element: {
                get: function () {
                    return this._element;
                }
            },
						/// <field type="String">
			/// Sets gets the pattern for positive numeric values, which is used in display (no focus) state.
///				The "$" flag represents "numericSymbol" and the "n" flag represents the value of number.
///				Note: this option has priority over possible regional settings.
			/// </field>
			positivePattern: {
				get: function () {
					return $(this._element).igPercentEditor('option', 'positivePattern');
				},
				set: function (value) {
					$(this._element).igPercentEditor('option', 'positivePattern', value);
				}
			},
			/// <field type="String">
			/// Sets gets the pattern for negative numeric values, which is used in display (no focus) state.
///				The "$" flag represents "numericSymbol".
///				The "n" flag represents the value of number.
///				The "-" and "()" flags are static part of pattern.
///				Note: this option has priority over possible regional settings.
			/// </field>
			negativePattern: {
				get: function () {
					return $(this._element).igPercentEditor('option', 'negativePattern');
				},
				set: function (value) {
					$(this._element).igPercentEditor('option', 'negativePattern', value);
				}
			},
			/// <field type="String">
			/// Sets gets symbol, which is used in display (no focus) state.
///				Note: this option has priority over possible regional settings.
			/// </field>
			symbol: {
				get: function () {
					return $(this._element).igPercentEditor('option', 'symbol');
				},
				set: function (value) {
					$(this._element).igPercentEditor('option', 'symbol', value);
				}
			},
			/// <field type="Number">
			/// Sets gets the factor which used for the get and set of the "value" method.
///				On the get number (string) entered by user is divided by that factor and on the set the number (string) displayed in editor is multiplied by that factor.
///				For example, if factor is 100 and the "value" is set to 0.123, then editor will show string "12.3".
///				Possible values: 1, 10, 100, 1000, 10000, 100000, etc.
///				Note: this option has priority over possible regional settings.
			/// </field>
			displayFactor: {
				get: function () {
					return $(this._element).igPercentEditor('option', 'displayFactor');
				},
				set: function (value) {
					$(this._element).igPercentEditor('option', 'displayFactor', value);
				}
			},

			// Public methods
			/*
			destroy: function igPercentEditor_destroy() {
				$(this._element).igPercentEditor('destroy');
			}
			*/
			
        }, {
			// Static members
		})
    });
}());