// igPieChart extension
/*global WinJS, $*/
(function () {
    WinJS.Namespace.define('Infragistics.UI', {
        PieChart: WinJS.Class.define(function (element, options) {
			// This needs to be defined for all widgets
            if (!element) {
                throw new Error("The Infragistics control requires a DOM element to be instantiated on.");
            }
			this._element = element;
			// Initializes the control
			MSApp.execUnsafeLocalFunction(function () {
				$(element).igPieChart(options);
			});
			this.element.winControl = this;
        }, {
			// Private properties
			_element: null,
            // Public options
			// The element option is generic for all widget and is only a getter
			element: {
                get: function () {
                    return this._element;
                }
            },
						/// <field type="Number">
			/// The width of the chart. It can be set as a number in pixels, string (px) or percentage (%).
			/// </field>
			width: {
				get: function () {
					return $(this._element).igPieChart('option', 'width');
				},
				set: function (value) {
					$(this._element).igPieChart('option', 'width', value);
				}
			},
			/// <field type="Number">
			/// The height of the chart. It can be set as a number in pixels, string (px) or percentage (%).
			/// </field>
			height: {
				get: function () {
					return $(this._element).igPieChart('option', 'height');
				},
				set: function (value) {
					$(this._element).igPieChart('option', 'height', value);
				}
			},
			/// <field type="Object">
			/// can be any valid data source accepted by $.ig.DataSource, or an instance of an $.ig.DataSource itself
			/// </field>
			dataSource: {
				get: function () {
					return $(this._element).igPieChart('option', 'dataSource');
				},
				set: function (value) {
					$(this._element).igPieChart('option', 'dataSource', value);
				}
			},
			/// <field type="String">
			/// Specifies a remote URL accepted by $.ig.DataSource in order to request data from it
			/// </field>
			dataSourceUrl: {
				get: function () {
					return $(this._element).igPieChart('option', 'dataSourceUrl');
				},
				set: function (value) {
					$(this._element).igPieChart('option', 'dataSourceUrl', value);
				}
			},
			/// <field type="String">
			/// Explicitly set data source type (such as "json"). Please refer to the documentation of $.ig.DataSource and its type property.
			/// </field>
			dataSourceType: {
				get: function () {
					return $(this._element).igPieChart('option', 'dataSourceType');
				},
				set: function (value) {
					$(this._element).igPieChart('option', 'dataSourceType', value);
				}
			},
			/// <field type="String">
			/// see $.ig.DataSource. Specifies the name of the property in which data records are held if the response is wrapped.
			/// </field>
			responseDataKey: {
				get: function () {
					return $(this._element).igPieChart('option', 'responseDataKey');
				},
				set: function (value) {
					$(this._element).igPieChart('option', 'responseDataKey', value);
				}
			},
			/// <field type="String">
			/// Gets or Sets the property name that contains the values.
			/// </field>
			valueMemberPath: {
				get: function () {
					return $(this._element).igPieChart('option', 'valueMemberPath');
				},
				set: function (value) {
					$(this._element).igPieChart('option', 'valueMemberPath', value);
				}
			},
			/// <field type="String">
			/// Gets or sets the property name that contains the labels.
			/// </field>
			labelMemberPath: {
				get: function () {
					return $(this._element).igPieChart('option', 'labelMemberPath');
				},
				set: function (value) {
					$(this._element).igPieChart('option', 'labelMemberPath', value);
				}
			},
			/// <field type="Enumeration">
			/// 
			/// </field>
			labelsPosition: {
				get: function () {
					return $(this._element).igPieChart('option', 'labelsPosition');
				},
				set: function (value) {
					$(this._element).igPieChart('option', 'labelsPosition', value);
				}
			},
			/// <field type="Enumeration">
			/// 
			/// </field>
			leaderLineVisibility: {
				get: function () {
					return $(this._element).igPieChart('option', 'leaderLineVisibility');
				},
				set: function (value) {
					$(this._element).igPieChart('option', 'leaderLineVisibility', value);
				}
			},
			/// <field type="Number">
			/// Gets or sets the threshold value that determines if slices are grouped into the Others slice.
			/// </field>
			othersCategoryThreshold: {
				get: function () {
					return $(this._element).igPieChart('option', 'othersCategoryThreshold');
				},
				set: function (value) {
					$(this._element).igPieChart('option', 'othersCategoryThreshold', value);
				}
			},
			/// <field type="Enumeration">
			/// 
			/// </field>
			othersCategoryType: {
				get: function () {
					return $(this._element).igPieChart('option', 'othersCategoryType');
				},
				set: function (value) {
					$(this._element).igPieChart('option', 'othersCategoryType', value);
				}
			},
			/// <field type="String">
			/// Gets or sets the label of the Others slice.
			/// </field>
			othersCategoryText: {
				get: function () {
					return $(this._element).igPieChart('option', 'othersCategoryText');
				},
				set: function (value) {
					$(this._element).igPieChart('option', 'othersCategoryText', value);
				}
			},
			/// <field type="Number">
			/// Determines how much the exploded slice is offset from the center. Value between 0 and 1.
			/// </field>
			explodedRadius: {
				get: function () {
					return $(this._element).igPieChart('option', 'explodedRadius');
				},
				set: function (value) {
					$(this._element).igPieChart('option', 'explodedRadius', value);
				}
			},
			/// <field type="Number">
			/// Gets or sets the scaling factor of the chart's radius. Value between 0 and 1.
			/// </field>
			radiusFactor: {
				get: function () {
					return $(this._element).igPieChart('option', 'radiusFactor');
				},
				set: function (value) {
					$(this._element).igPieChart('option', 'radiusFactor', value);
				}
			},
			/// <field type="Bool">
			/// Gets or sets whether the slices can be selected.
			/// </field>
			allowSliceSelection: {
				get: function () {
					return $(this._element).igPieChart('option', 'allowSliceSelection');
				},
				set: function (value) {
					$(this._element).igPieChart('option', 'allowSliceSelection', value);
				}
			},
			/// <field type="Bool">
			/// Gets or sets whether the slices can be exploded.
			/// </field>
			allowSliceExplosion: {
				get: function () {
					return $(this._element).igPieChart('option', 'allowSliceExplosion');
				},
				set: function (value) {
					$(this._element).igPieChart('option', 'allowSliceExplosion', value);
				}
			},
			/// <field type="Array">
			/// Gets or sets the collection of exploded slice indices.
///            Should be an array of integers that indicate the indexes of the slices to explode.
			/// </field>
			explodedSlices: {
				get: function () {
					return $(this._element).igPieChart('option', 'explodedSlices');
				},
				set: function (value) {
					$(this._element).igPieChart('option', 'explodedSlices', value);
				}
			},
			/// <field type="Bool">
			/// Whether the chart should render a tooltip.
			/// </field>
			showTooltip: {
				get: function () {
					return $(this._element).igPieChart('option', 'showTooltip');
				},
				set: function (value) {
					$(this._element).igPieChart('option', 'showTooltip', value);
				}
			},
			/// <field type="String">
			/// The name of template or the template itself that chart tooltip will use to render.
			/// </field>
			tooltipTemplate: {
				get: function () {
					return $(this._element).igPieChart('option', 'tooltipTemplate');
				},
				set: function (value) {
					$(this._element).igPieChart('option', 'tooltipTemplate', value);
				}
			},
			/// <field type="Object">
			/// can be any valid options accepted by $.ig.ChartLegend, or an instance of an $.ig.ChartLegend itself.
			/// </field>
			legend: {
				get: function () {
					return $(this._element).igPieChart('option', 'legend');
				},
				set: function (value) {
					$(this._element).igPieChart('option', 'legend', value);
				}
			},
			/// <field type="Number">
			/// Gets or sets the pixel amount, by which the labels are offset from the edge of the slices.
			/// </field>
			labelExtent: {
				get: function () {
					return $(this._element).igPieChart('option', 'labelExtent');
				},
				set: function (value) {
					$(this._element).igPieChart('option', 'labelExtent', value);
				}
			},
			/// <field type="Number">
			/// Gets or sets the starting angle of the chart.
///			The default zero value is equivalent to 3 o'clock.
			/// </field>
			startAngle: {
				get: function () {
					return $(this._element).igPieChart('option', 'startAngle');
				},
				set: function (value) {
					$(this._element).igPieChart('option', 'startAngle', value);
				}
			},
			/// <field type="Enumeration">
			/// 
			/// </field>
			sweepDirection: {
				get: function () {
					return $(this._element).igPieChart('option', 'sweepDirection');
				},
				set: function (value) {
					$(this._element).igPieChart('option', 'sweepDirection', value);
				}
			},
			/// <field type="Object">
			/// Gets or sets the style used when a slice is selected.
			/// </field>
			selectedStyle: {
				get: function () {
					return $(this._element).igPieChart('option', 'selectedStyle');
				},
				set: function (value) {
					$(this._element).igPieChart('option', 'selectedStyle', value);
				}
			},
			/// <field type="Object">
			/// Gets or sets the Brushes property.
///			The brushes property defines the palette from which automatically assigned slice brushes are selected.
///			The value provided should be an array of css color strings. Optionally the first element can be a string reading "RGB" or "HSV" to specify the interpolation mode of the collection.
			/// </field>
			brushes: {
				get: function () {
					return $(this._element).igPieChart('option', 'brushes');
				},
				set: function (value) {
					$(this._element).igPieChart('option', 'brushes', value);
				}
			},
			/// <field type="Object">
			/// Gets or sets the Outlines property.
///			The Outlines property defines the palette from which automatically assigned slice outlines are selected.
///			The value provided should be an array of css color strings. Optionally the first element can be a string reading "RGB" or "HSV" to specify the interpolation mode of the collection.
			/// </field>
			outlines: {
				get: function () {
					return $(this._element).igPieChart('option', 'outlines');
				},
				set: function (value) {
					$(this._element).igPieChart('option', 'outlines', value);
				}
			},
			/// <field type="Object">
			/// Gets or sets the LegendItemTemplate property.
///			The legend item control content is created according to the LegendItemTemplate on-demand by
///			the chart object itself.
///			The provided object should have properties called render and optionally measure. See definition for option: legendItemBadgeTemplate
			/// </field>
			legendItemTemplate: {
				get: function () {
					return $(this._element).igPieChart('option', 'legendItemTemplate');
				},
				set: function (value) {
					$(this._element).igPieChart('option', 'legendItemTemplate', value);
				}
			},
			/// <field type="Object">
			/// Gets or sets the LegendItemBadgeTemplate property.
///			The legend item badge is created according to the LegendItemBadgeTemplate on-demand by
///			the chart object itself.
///			The provided object should have properties called render and optionally measure. See definition for option: legendItemBadgeTemplate
			/// </field>
			legendItemBadgeTemplate: {
				get: function () {
					return $(this._element).igPieChart('option', 'legendItemBadgeTemplate');
				},
				set: function (value) {
					$(this._element).igPieChart('option', 'legendItemBadgeTemplate', value);
				}
			},
			/// <field type="String">
			/// Overrides the style used for text in the pie chart.
			/// </field>
			textStyle: {
				get: function () {
					return $(this._element).igPieChart('option', 'textStyle');
				},
				set: function (value) {
					$(this._element).igPieChart('option', 'textStyle', value);
				}
			},

			// Public methods
			/*
			destroy: function igPieChart_destroy() {
				$(this._element).igPieChart('destroy');
			}
			*/
						/* adds a new item to the data source and notifies the chart.
			*/
            addItem: function PieChart_addItem (item) {
                $(this._element).igPieChart('addItem', item);
            },
			/* inserts a new item to the data source and notifies the chart.
			*/
            insertItem: function PieChart_insertItem (item, index) {
                $(this._element).igPieChart('insertItem', item, index);
            },
			/* deletes an item from the data source and notifies the chart.
			*/
            removeItem: function PieChart_removeItem (index) {
                $(this._element).igPieChart('removeItem', index);
            },
			/* updates an item in the data source and notifies the chart.
			*/
            setItem: function PieChart_setItem (index, item) {
                $(this._element).igPieChart('setItem', index, item);
            },
			/* Exports the chart to a PNG image.
			*/
            exportImage: function PieChart_exportImage (width, height) {
                $(this._element).igPieChart('exportImage', width, height);
            },
			/* Destroys the widget.
			*/
            destroy: function PieChart_destroy () {
                $(this._element).igPieChart('destroy');
            },
			/* returns the ID of parent element holding the chart.
			*/
            id: function PieChart_id () {
                $(this._element).igPieChart('id');
            },
			/* Returns the element holding the chart.
			*/
            widget: function PieChart_widget () {
                $(this._element).igPieChart('widget');
            },
			/* Creates a print preview page with the chart, hiding all other elements on the page.
			*/
            print: function PieChart_print () {
                $(this._element).igPieChart('print');
            }

        }, {
			// Static members
		})
    });
}());